package net.vodanh9x;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;

public class Main extends MIDlet
{
    public void startApp(){
        canvas cv;
        Display.getDisplay(this).setCurrent(cv = new canvas());
        new Thread(cv).start();
    }
    public void pauseApp(){
    }
    public void destroyApp(boolean b) {
    }
}

class canvas extends Canvas implements Runnable{
    boolean isrun;
    static int w, h;
    Vector V= new Vector();
    static final int[] mau ={
        0xff0000,
        0x00ff00,
        0x0000ff,
        0xcccc00,
        0xcc00cc,
        0x00cccc
    }
    ;
    
    public canvas(){
        setFullScreenMode(true);
        w=getWidth();
        h=getHeight();
    }
    
    /*run*/
    public void run(){
        isrun = true;
        while(isrun){
            updateInfo();
            repaint();
            try{
                Thread.sleep(145l);
            }
            catch(Exception e){
            }
        }
    }
    /*run*/
    
    
    public void keyPressed(int k){
        if(k==-5)
        if(V.size() < 12){
            //nếu trên màn hình có dưới 12quả thì bắn thêm
            add();
        }
    }
    
    /*thêm pháo hoa*/
    void add(){
        V.addElement(new ph());
    }
    /*thêm pháo hoa*/
    
    /*hoạt động của pháo hoa*/
    void updateInfo(){
        for(int i=0;i<V.size();++i){
            ph p;
            (p = (ph) V.elementAt(i)).dichuyen();
            if(p.giaidoan>15) V.removeElementAt(i);
        }
    }
    /*hoạt động của pháo hoa*/
    
    public void paint(Graphics g){
        g.setColor(0);
        g.fillRect(0,0,w,h);
        for(int i=0;i<V.size();++i){
            ((ph) V.elementAt(i)).draw(g);
        }
    }
}

class ph{
    int[] tialua = new int[120];
    //khoảng cách giữa 2lần update vị trí gần nhau
    int quangdi;
    //và fl là độ dài tia lửa
    int fl;
    int giaidoan=0;
    int x0, y0, x, y, alpha;
    
    public ph(){
        Random rd=new Random();
        
        /*
        chúng ta cần quãng di chuyển và độ dài tia lửa khác nhau
        để tạo hiệu ứng xa-gần với ta và
        nếu random được chiều dài tia lửa =0 tức là quả đó sẽ bị xịt @@
        */
        quangdi = (     fl = Math.abs(rd.nextInt()%(canvas.h/30))     )+13;
        
        for(int i=0;i<120;++i) tialua[i] = canvas.mau[Math.abs(rd.nextInt()%canvas.mau.length)];
        x0 = Math.abs(rd.nextInt()%canvas.w);
        y0 = canvas.h - Math.abs(rd.nextInt()%(canvas.h/4));
        
        //cho góc alpha nhận giá trị ngẫu nhiên tứ 45 đến 135 độ
        alpha=rd.nextInt()%45+90;
    }
    
    void dichuyen(){
        ++giaidoan;
        if(giaidoan<8){
            
            /*
            chỉ update x và y
            khi quả pháo bay chưa được 8 đoạn
            để lấy mốc tọa độ nổ tính tọa độ tia lửa sau đó
            */
            
            //x=x0+at
            x = x0 + (int)   (giaidoan*(quangdi*Math.cos(Math.toRadians(alpha))));
            //y=y0-bt
            y = y0 - (int)    (giaidoan*(quangdi*Math.sin(Math.toRadians(alpha))));
        }
    }
    
    void draw(Graphics g){
        if(giaidoan<8){
            //vẽ quả pháo trước khi nổ
            g.setColor(0x0033ff);
            g.fillRect(x-1,y-1,2,2);
        }
        else
        {
            /*002*/
            //cho nổ sau khi bay 8 đoạn:
            for(int i=0;i<120;++i){
                /*for*/
                //mấy phép trừ đi 8 or 7 or 6 là để xem tia lửa đã bay được mấy đoạn sau khi nó xuất hiện
                if(i%2==0){
                    //vẽ tia lửa dài hơn ở vòng trong
                    int a = (int) ((fl*(giaidoan-8))*Math.cos(Math.toRadians(i*3)));
                    int b = (int) ((fl*(giaidoan-8))*Math.sin(Math.toRadians(i*3)));
                    int c = (int) ((fl*(giaidoan-7))*Math.cos(Math.toRadians(i*3)));
                    int d = (int) ((fl*(giaidoan-7))*Math.sin(Math.toRadians(i*3)));
                    g.setColor(tialua[i]);
                    g.drawLine(x+a, y+b,x+c,y+d);
                }
                else{
                    //xen kẽ là những điểm sáng vòng ngoài:
                    int e = (int) ((fl*(giaidoan-6))*Math.cos(Math.toRadians(i*3)));
                    int f = (int) ((fl*(giaidoan-6))*Math.sin(Math.toRadians(i*3)));
                    g.setColor(tialua[i]);
                    g.drawLine(x+e, y+f,x+e,y+f);
                }
                /*endfor*/
            }
            /*002*/
        }
    }
}

